config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  get 'password_resets/new'

  get 'password_resets/edit'

  get 'sessions/new'

  get '/help',      to: 'static_pages#help'
  get '/signup',    to: 'users#new'
  post '/signup',   to: 'users#create'
  get '/login',     to: 'sessions#new'
  post '/login',    to: 'sessions#create'
  delete '/logout', to: 'sessions#destroy'
  put '/tts',       to: 'users#tts'

  resources :dictionaries do
    collection do
      post 'export_multiple'
    end
    post 'export', on: :member
    resources :entries do
      member do
        post 'finalize'
        post 'play'
        get 'play'
      end
    end
  end
  resources :sampas
  resources :users
  resources :account_activations, only: [:edit]
  resources :password_resets, only: %i[new create edit update]

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root 'dictionaries#index'
end

app/models/entry.rb
# frozen_string_literal: true

class Entry < ApplicationRecord
  include ::EntryConcern

  belongs_to :dictionary
  belongs_to :user, default: -> { Current.user }

  scope :ordered, -> { order(word: :asc) }
  scope :with_word, ->(pattern) { where('word like  ?', pattern) }
  scope :with_sampa, ->(pattern) { where('sampa like  ?', pattern) }
  scope :with_comment, ->(pattern) { where('comment like  ?', pattern) }
  scope :with_warning, -> { where(warning: true) }
  scope :version_eq, ->(version) { joins(:dictionary).where('dictionaries.version = ?', version) }

  validates :word, presence: true
  validates :lang, inclusion: { in: ISO3166::Country.codes,
                                message: '(%{value}) is not a valid ISO3166 country code' }
  validates :pos, inclusion: { in: pos_available,
                               message: '(%{value}) is not a supported PoS tag' }
  validates :dialect, inclusion: { in: dialects_available,
                                   message: '(%{value}) is not a supported pronunciation variant' }
  validates :comp_part, inclusion: { in: compound_parts_available,
                                     message: '(%{value}) is not a supported compound part' }
  before_save :strip_whitespace, :update_warning

  # add validation: unique per dictionary ...

  # Returns if sampa is correct according to given phoneme list
  def sampa_correct?(phonemes)
    return false if sampa.nil?

    (sampa.split.uniq - phonemes).empty?
  end

  # Validates, if given PoS (Part of Speech) tag is supported
  def pos_supported?(pos)
    pos_available.include?(pos)
  end

  # Validates, if given dialect is supported
  def dialect_supported?(dialect)
    dialects_available.include?(dialect)
  end

  # Validates, if given compound part is supported
  def comp_part_supported?(comp_part)
    compound_parts_available.include?(comp_part)
  end

  private

  def update_warning
    return unless dictionary.sampa

    phonemes = dictionary.sampa.phonemes.split
    self.warning = !sampa_correct?(phonemes)
  end

  # Strips leading/trailing whitespace from attributes
  #   - word
  #   - sampa
  #   - comment
  def strip_whitespace
    self.word = word.strip unless word.nil?
    self.sampa = sampa.strip unless sampa.nil?
    self.comment = comment.strip unless comment.nil?
  end
end

app/controllers/entries_controller.rb
# frozen_string_literal: true

class EntriesController < ApplicationController
  before_action :log_in
  before_action :set_entry, only: %i[show edit update destroy finalize play]
  before_action :set_cache_headers
  include SessionsHelper

  # GET /entries
  # GET /entries.json
  def index
    if params[:dictionary_id]
      @dictionary = Dictionary.find(params[:dictionary_id])
      @entries = @dictionary.entries
    else
      @entries = Entry.all
    end
  end

  # GET /entries/1
  # GET /entries/1.json
  def show; end

  # GET /entries/new
  def new
    @dictionary = Dictionary.find(params[:dictionary_id])
    @entry = Entry.new
    @url = dictionary_entries_path(@dictionary)
  end

  # GET /entries/1/edit
  def edit
    @url = dictionary_entry_path(@dictionary, @entry)
    @avail_pos = Entry.pos_available
    @avail_dialects = Entry.dialects_available
    @avail_comp_parts = Entry.compound_parts_available
    @avail_pos = Entry.pos_available
  end

  # POST /entries
  # POST /entries.json
  def create
    @entry = Entry.new(entry_params)
    @dictionary = Dictionary.find(params[:dictionary_id])
    respond_to do |format|
      if @entry.save
        format.html { redirect_to dictionary_entry_path(@dictionary, @entry),
                                  notice: 'Entry was successfully created.' }
        format.json { render :show, status: :created, location: @entry }
      else
        format.html { render :new }
        format.json { render json: @entry.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /entries/1
  # PATCH/PUT /entries/1.json
  def update
    respond_to do |format|
      # Policy: also update finished attribute to true if form was submitted
      if @entry.update(entry_params.merge({ finished: true }))
        format.js { render partial: 'update.js' }
        redir_url = cookies[:before_url].nil? ? dictionary_url(@dictionary) : cookies[:before_url]
        format.html { redirect_to redir_url }
        format.json { render :show, status: :ok, location: @entry }
      else
        format.js {}
        format.html { render :edit }
        format.json { render json: @entry.errors, status: :unprocessable_entity }
      end
    end
  end

  # POST /entries/1/
  def finalize
    is_final = params['Correct'] || false
    respond_to do |format|
      if @entry.update({ finished: is_final })
        format.js { head :ok }
      else
        flash[:warning] = "Could not update value: #{@entry.errors.full_messages}"
        logger.warn @entry.errors.full_messages.to_s
        redirect_to(dictionary_path(@dictionary)) and return
      end
    end
  end

  # DELETE /entries/1
  # DELETE /entries/1.json
  def destroy
    @entry.destroy
    respond_to do |format|
      format.html { redirect_to dictionary_entries_url(@dictionary),
                                notice: 'Entry was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  # plays the given Sampa by reaching out to Amazon Polly web-service
  def play
    voice = User.find_by(id: current_user.id).tts_voice
    logger.info '================ START TTS ==============='
    answer_audio_file = TtsService.call(@entry, voice)
    logger.info '================ END TTS ==============='
    respond_to do |format|
      format.html do
        response.headers["Cache-Control"] = "no-cache, no-store"
        response.headers["Pragma"] = "no-cache"
        response.headers["Expires"] = "Mon, 01 Jan 1990 00:00:00 GMT"
        expires_in 1.seconds, public: true
        send_file(answer_audio_file, type: 'audio/mpeg', disposition: 'inline')
      end
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_entry
    @entry = Entry.find(params[:id])
    @dictionary = @entry.dictionary
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def entry_params
    params.require(:entry).permit(:word, :sampa, :comment, :user_id, :dictionary_id,
                                  :warning, :finished, :pos, :lang, :is_compound, :comp_part,
                                  :prefix, :dialect)
  end

  def log_in
    redirect_to help_path unless helpers.logged_in?
  end

  def set_cache_headers
    response.headers['Cache-Control'] = 'no-cache, no-store'
    response.headers['Pragma'] = 'no-cache'
    response.headers['Expires'] = 'Mon, 01 Jan 1990 00:00:00 GMT'
  end
end

app/helpers/entries_helper.rb
# frozen_string_literal: true

module EntriesHelper
end

app/views/entries/_entry.html.erb
<div class="divTableRow <%= entry.finished ? 'finished' : ''%> <%= entry.warning ? 'warning' : ''%>">

  <div class="divTableCell divTableCell__entry">
    <%= link_to "#{entry.word}", edit_dictionary_entry_path(@dictionary, entry), remote: true  %>
  </div>
  <div class="divTableCell divTableCell__sampa"><%= entry.sampa %></div>
  <div class="divTableCell divTableCell__player">
    <button class="entry-audio-player" data-status="inactive" title="play"  data-src="<%= play_dictionary_entry_path(@dictionary, entry)%>">
      <svg class="entry-audio-player__play" xmlns="http://www.w3.org/2000/svg" fill="currentColor" class="bi bi-play-circle" viewBox="0 0 16 16">
        <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"/>
        <path d="M6.271 5.055a.5.5 0 0 1 .52.038l3.5 2.5a.5.5 0 0 1 0 .814l-3.5 2.5A.5.5 0 0 1 6 10.5v-5a.5.5 0 0 1 .271-.445z"/>
      </svg>
      <svg class="entry-audio-player__pause" xmlns="http://www.w3.org/2000/svg"  fill="currentColor" class="bi bi-pause-circle" viewBox="0 0 16 16">
        <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"/>
        <path d="M5 6.25a1.25 1.25 0 1 1 2.5 0v3.5a1.25 1.25 0 1 1-2.5 0v-3.5zm3.5 0a1.25 1.25 0 1 1 2.5 0v3.5a1.25 1.25 0 1 1-2.5 0v-3.5z"/>
    </svg>
    </button>

  </div>
  <div class="divTableCell divTableCell__comment">
    <% if entry.comment != "" %>
      <span title="<%= entry.comment %>">
        <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-card-text" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
          <path fill-rule="evenodd" d="M14.5 3h-13a.5.5 0 0 0-.5.5v9a.5.5 0 0 0 .5.5h13a.5.5 0 0 0 .5-.5v-9a.5.5 0 0 0-.5-.5zm-13-1A1.5 1.5 0 0 0 0 3.5v9A1.5 1.5 0 0 0 1.5 14h13a1.5 1.5 0 0 0 1.5-1.5v-9A1.5 1.5 0 0 0 14.5 2h-13z"/>
          <path fill-rule="evenodd" d="M3 5.5a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9a.5.5 0 0 1-.5-.5zM3 8a.5.5 0 0 1 .5-.5h9a.5.5 0 0 1 0 1h-9A.5.5 0 0 1 3 8zm0 2.5a.5.5 0 0 1 .5-.5h6a.5.5 0 0 1 0 1h-6a.5.5 0 0 1-.5-.5z"/>
        </svg>
      </span>
    <%end %>
  </div>
  <div class="divTableCell divTableCell__correct">
    <%= check_box_tag 'Correct', entry.id, entry.finished, :data => {
        :remote => true,
        :url => finalize_dictionary_entry_path(@dictionary, entry),
        :method => :post
      }, class: 'correct-check'
    %>
  </div>
  <div class="divTableCell -row2">
    <div class="pill"><%="#{entry.lang}"%></div>
    <% if entry.lang != 'none' %>
      <div class="pill"><%="#{entry.dialect}"%></div>
    <%end %>
    <div class="pill"><%="#{t('compound part')}: #{entry.comp_part}"%></div>
    <div class="pill"><%="#{t('is compound')}: #{entry.is_compound}"%></div>
    <div class="pill"><%="#{t('has prefix')}: #{entry.prefix}"%></div>
    <% if entry.pos != 'none' %>
      <div class="pill"><%="#{t('POS')}: #{entry.pos}"%></div>
    <%end %>
  </div>
</div>

app/views/entries/_form.html.erb
<%= form_with(model: entry, url: @url, local: true) do |form| %>
  <% if entry.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(entry.errors.count, "error") %> prohibited this entry from being saved:</h2>

      <ul>
        <% entry.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-row">
    <div class="col-md-4 mb-2">
      <%= form.label :word %>
      <%= form.text_field :word, class: 'form-control' %>
    </div>

    <div class="col-md-4 mb-2">
      <%= form.label :sampa %>
      <%= form.text_field :sampa, class: 'form-control' %>
    </div>

    <div class="col-md-4 mb-2">
      <%= form.label :comment %>
      <%= form.text_area :comment, class: 'form-control' %>
    </div>
  </div>
  <div class="form-group">
    <div class="form-check">
      <%= form.check_box :finished, class: 'form-check-input', id: 'entry_is_finished' %>
      <%= form.label t('Finished'), class: 'form-check-label', for: 'entry_is_finished' %>
    </div>
  </div>
  <div class="form-group">
    <div class="btn btn-primary">
      <%= form.submit %>
    </div>
  </div>

<% end %>

app/views/entries/_inline_form.html.erb
<div class="divTableRow divTableRow--form">

<%= form_with model: entry, url: [@dictionary, entry], class: 'divTableCell', id: dom_id(entry, 'inline_form') do |form| %>

  <div class="divTableCell form-group">
    <%= form.label t(:Word) %>
    <%= form.text_field :word, class:"form-control"%>
  </div>

  <div class="divTableCell form-group">
      <%= form.label t(:Sampa) %>
    <%= form.text_field :sampa,  id:"sampa-#{entry.id}", class:"form-control" %>
  </div>

  <div class="divTableCell form-group">
  <%= form.label t(:Comment) %>
    <%= form.text_field :comment, class:"form-control"%>
  </div>

   <div class="divTableCell form-group">
   <%= form.label t(:Pos)%>
     <%= form.select :pos, @avail_pos, {}, class:"form-control" %>
  </div>
   <div class="divTableCell form-group">
   <%= form.label t(:Lang) %>
     <%= form.select :lang, %w[IS GB], {}, class:"form-control" %>
  </div>
   <div class="divTableCell form-check">
     <%= form.check_box :is_compound, class:"form-check-input", type:"checkbox" %>
     <%= form.label t(:Compound), class: "form-check-label" %>
  </div>
   <div class="divTableCell form-group">
   <%= form.label t('Component part') %>
     <%= form.select :comp_part, @avail_comp_parts, {}, class:"form-control" %>
  </div>
  
   <div class="divTableCell form-group">
     <%= form.label t(:Dialect) %>
     <%= form.select :dialect, @avail_dialects, {}, class:"form-control" %>
  </div>
   <div class="divTableCell form-check">
     <%= form.check_box :prefix, class:"form-check-input", type:"checkbox" %>
     <%= form.label t(:Prefix), class: "form-check-label" %>
  </div>
   <div class="divTableCell -update form-group">
    <%= form.submit class:'btn btn-success'%> 
  </div>
    <button type="button" class="close closeRow" aria-label="Close">
      <span aria-hidden="true" >&times;</span>
    </button>
<% end %>
</div>

app/views/entries/_update.js.erb
document.getElementById('<%= dom_id(@entry, 'inline_form') %>').remove()
document.getElementById('<%= dom_id(@entry) %>').innerHTML = "<%= j render @entry %>"
document.getElementById('<%= dom_id(@entry) %>').classList.remove('edit');

app/views/entries/edit.html.erb
<br>
<h2>Edit Entry</h2>
<% #noinspection RailsParamDefResolve
   cookies[:before_url] = url_for(:back) %>
<%= render 'form', entry: @entry %>

<%= link_to 'Back', :back %>

app/views/entries/edit.js.erb
document.getElementById('<%= dom_id(@entry) %>').insertAdjacentHTML('beforeend', "<%= j render 'inline_form', entry: @entry %>")
document.getElementById('<%= dom_id(@entry) %>').classList.add('edit')
document.getElementById('sampa-<%= @entry.id %>').focus()

app/views/entries/index.html.erb
<p id="notice"><%= notice %></p>

<h2>Entries</h2>

<table class="table">
  <thead>
    <tr>
      <th scope="col">Word</th>
      <th scope="col">SAMPA</th>
      <th scope="col">Comment</th>
      <th scope="col">Modified</th>
    </tr>
  </thead>

  <tbody>
    <% @entries.each do |entry| %>
      <tr>
        <td><%= entry.word %></td>
        <td><%= entry.sampa %></td>
        <td><%= entry.comment %></td>
        <td><%= entry.updated_at %></td>
        <td><%= link_to t('Show'), dictionary_entry_path(@dictionary, entry) %></td>
        <td><%= link_to t('Edit'), edit_dictionary_entry_path(@dictionary, entry) %></td>
        <td><%= link_to t('Destroy'), dictionary_entry_path(@dictionary, entry), method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to t('New Entry'), new_dictionary_entry_path(@dictionary) %>

app/views/entries/new.html.erb
<h2>New Entry</h2>

<%= render 'form', entry: @entry, url: new_dictionary_entry_path(@dictionary) %>

<%= link_to 'Back', :back %>

app/views/entries/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong><%= t('Word') %>:</strong>
  <%= @entry.word %>
</p>

<p>
  <strong><%= t('SAMPA') %>:</strong>
  <%= @entry.sampa %>
</p>

<p>
  <strong><%= t('Comment') %>:</strong>
  <%= @entry.comment %>
</p>

<p>
  <strong><%= t('Modified') %>:</strong>
  <%= @entry.updated_at %>
</p>

<%= link_to t('Edit'), edit_dictionary_entry_path(@dictionary, @entry) %> |
<%= link_to t('Back'), :back %>